#define TITLE "SAVE DUMP" "\n" __DATE__ " " __TIME__


//////////////////////////////////////////////////////////////////////
// Simple consol print demo
// -- dovoto
//////////////////////////////////////////////////////////////////////

#include <stdio.h>
#include <stdlib.h>
#include <time.h>

#include <NDS/NDS.h>

#include <NDS/ARM9/console.h> //basic print funcionality
#include <NDS/ARM9/CP15.h>
#include "ndsetc.h"

#include "boolean.h"
#include "../../ipc2.h"
#include "waveprint.h"

#define SOUND_FORMAT_16BIT (0)
#define SOUND_FORMAT_8BIT (1)


char WeekStr[][4]={"SUN","MON","TUE","WED","THU","FRI","SAT"};



//	j𓾂
int getwday(tm *tmp)
{
	int w;
	tm t;
	t=*tmp;
	
	if (t.tm_mon < 3) {t.tm_year--; t.tm_mon += 12;}
	w = 
	(
		t.tm_year
		+ t.tm_year/4 
		- t.tm_year/100 
		+ t.tm_year/400
		+ (13*t.tm_mon+8)/5
		+ t.tm_mday
	)%7;
	tmp->tm_wday=w;
	return w;
}

void dumpdata(void)
{
		char msg[1024];
      char msg0[1024];
      char msg1[1024];
      char msg2[1024];
      uint8 data[1024];
      uint32 i=0;
      int j;
	
      snprintf(msg,sizeof(msg),"\n\n" TITLE " DUMP START !!\n\n");
      wpr_WriteString(msg);
      wpr_DrainPCM();

      for(i=0;i<4*1024;i+=16)
      {
      snprintf(msg0,sizeof(msg0),"%08X:",0xFFFF0000 + i);
//      consolePrintf(msg0);
//      cardReadEeprom(i, data, 16, 0xffff);

      	for(j=0;j<16;j++)
      	{
      		uint8 d;
      		uint8 *p=(uint8 *)0xFFFF0000;
      		d=data[j]=p[i+j];
      		//msg1
      		sprintf(msg1 + j*3,"%02X ",d);
      		//msg2
				if(d>=0x20 && d<0x80)
				{
				msg2[j]=d;
				}
				else
				{
				msg2[j]='.';
				}
				msg[0]=msg2[j];
				msg[1]=0;
      		//	consolePrintf(msg);
      	}
      	msg2[16]=0;
      	msg1[16*3]=0;
//      	snprintf(msg,sizeof(msg),"%s%s %s\r\n",msg0,msg1,msg2);
      	snprintf(msg,sizeof(msg),"%s%s\n",msg0,msg1);

		consolePrintSet(0,6);
      	consolePrintf(msg);

      wpr_WriteString(msg);
      wpr_DrainPCM();

      wpr_WriteString(msg);
      wpr_DrainPCM();
//      consolePrintf("\n");
      }

//      consolePrintf("OK\n");
}


int main(void)
{
  videoSetMode(0); //not using the main screen
  videoSetModeSub(MODE_0_2D | DISPLAY_BG0_ACTIVE); //sub bg 0 will be used to print text
  vramSetBankC(VRAM_C_SUB_BG);
  
  SUB_BG0_CR = BG_MAP_BASE(31);

  BG_PALETTE_SUB[255] = RGB15(31,31,31);//by default font will be rendered with color 255

  //consoleInit() is a lot more flexible but this gets you up and running quick
  consoleInitDefault((u16*)SCREEN_BASE_BLOCK_SUB(31), (u16*)CHAR_BASE_BLOCK_SUB(0), 16);

  consolePrintf("\n\t" TITLE "\n");

//  consolePrintSet(0,5);
//  consolePrintf("SAVE DUMP\n");
  
  consolePrintf("A...DUMP START\n");
  
  wpr_Init();
  
  b8 DragFlag=False;
  s32 lastx=0,lasty=0;
  s32 lastsec=0;
  
  while(1)
  {
  	if(isEXE)
  	{
  		dumpdata();
  		nkeywait();
  	}
  	wait(1);
  }
  
/*
  
  while(1)
  {
    b32 touchPush;
    s32 touchXpx;
    s32 touchYpx;
    
    touchXpx=IPC2->touchXpx;
    touchYpx=IPC2->touchYpx;
    if(touchXpx>=256) touchXpx=0;
    if(touchYpx>=192) touchXpx=0;
    

    if((touchXpx!=0)&&(touchYpx!=0)){
      touchPush=True;
      }else{
      touchPush=False;
    }
    
    //move the cursor
    consolePrintSet(0,10);
    consolePrintf("Touch xpx = %3d\n", touchXpx);
    consolePrintf("Touch ypx = %3d\n", touchYpx);
    consolePrintf("Touch aux = %04X\n", IPC2->aux);
    consolePrintf("Touch bat = %04X\n", IPC2->battery);
    consolePrintf("SoundEnableFlags = %08b\n", IPC2->SoundEnableFlags);
    
    time2(&curtim);
    
    consolePrintSet(0,7);
    consolePrintf("%04d/%2d/%2d %2d:%02d:%02d (%s)\n",curtim.tm_year,curtim.tm_mon,curtim.tm_mday,curtim.tm_hour,curtim.tm_min,curtim.tm_sec,WeekStr[getwday(&curtim)]);
    
    if(lastsec!=curtim.tm_sec){
      char msg[256];
      
      snprintf(msg,256,"%04d/%2d/%2d %2d:%02d:%02d (%s)\r\n",curtim.tm_year,curtim.tm_mon,curtim.tm_mday,curtim.tm_hour,curtim.tm_min,curtim.tm_sec,WeekStr[getwday(&curtim)]);
      wpr_WriteString(msg);
      wpr_DrainPCM();
      
      lastsec=curtim.tm_sec;
    }
    
    if(touchPush==True){
      if(DragFlag==False){
        DragFlag=True;
        
        wpr_WriteString("TouchPush\r\n");
        wpr_DrainPCM();
      }
      
      if((lastx!=touchXpx)||(lasty!=touchYpx)){
        char msg[256];
        
        snprintf(msg,256,"Touch Pixel=(%3d,%3d)\r\n",touchXpx,touchYpx);
        wpr_WriteString(msg);
        wpr_DrainPCM();
      }
      
      }else{
      if(DragFlag==True){
        DragFlag=False;
        
        wpr_WriteString("TouchRelease\r\n");
        wpr_DrainPCM();
      }
    }
    
    lastx=touchXpx;
    lasty=touchYpx;


  }
*/
  
  wpr_Free();
  return 0;
}
