unit wavereadWin;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ddsd, ExtCtrls, StdCtrls, MPlayer,_PicTools, ComCtrls;

type
  TMain = class(TForm)
    DDSD: TDDSD;
    Timer1: TTimer;
    Memo1: TMemo;
    ListBox1: TListBox;
    maxlevImg: TImage;
    recborderBar: TTrackBar;
    recborderLbl: TLabel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Timer1Timer(Sender: TObject);
    procedure recborderBarChange(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
    DDSDRecord:TDDSDCapture;
    procedure DDSDRecordUpdate(Sender:TDDSDCapture; StartOffset,bufferSize:DWord);
    procedure StartRecord;
  end;

var
  Main: TMain;

implementation

{$R *.dfm}

const recsize=(44100*160) div 1000;//16*1024;

var
  recbuf:array[0..recsize] of smallint;
  recflag:boolean;
  recborder:integer;
  lastdata:smallint;
  logwfs:TFileStream;

procedure TMain.DDSDRecordUpdate(Sender:TDDSDCapture; StartOffset,bufferSize:DWord);
begin
  if recflag=True then begin
    memo1.Text:=memo1.Text+'overflow.';
    exit;
  end;

  recflag:=True;
  DDSDRecord.BlockCopy(StartOffset, @recbuf[0], BufferSize);
end;

var
  count:integer;
  bytecount:integer;
  bytedata:byte;
  datastr:string;

procedure TMain.FormCreate(Sender: TObject);
begin
  MakeBlankImg(maxlevImg,pf24bit);

  Main.Caption:='WavePrint 22050Hz.';

  recflag:=False;
  datastr:='';
  Memo1.Clear;

  recborder:=1024;

  recborderBar.Max:=$7fff;
  recborderBar.Position:=$7fff-recborder;

  try
    logwfs:=TFileStream.Create(changefileext(Application.ExeName,'.log'),fmCreate);
    except else
    logwfs:=nil;
  end;

  StartRecord;
  Timer1.Enabled:=True;
end;

procedure TMain.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  DDSDRecord.Stop;
  DDSDRecord.Free;

  logwfs.Free;
  logwfs:=nil;
end;

procedure recvBitStream(bitwidth:integer);
begin
  if bitwidth<2 then begin
    exit;
  end;

  if bitwidth<6 then begin
    if bytecount<8 then begin
      bytedata:=bytedata or (1 shl bytecount);
      inc(bytecount);
      if bytecount=8 then begin
        datastr:=datastr+char(bytedata);
      end;
    end;
    exit;
  end;

  if bitwidth<10 then begin
    if bytecount<8 then begin
      bytedata:=bytedata or (0 shl bytecount);
      inc(bytecount);
      if bytecount=8 then begin
        datastr:=datastr+char(bytedata);
      end;
    end;
    exit;
  end;

  if bitwidth<14 then begin
    bytedata:=0;
    bytecount:=0;
    exit;
  end;

end;

procedure TMain.Timer1Timer(Sender: TObject);
var
  cnt:integer;
  data:integer;
  maxlev:integer;
  maxlevy:integer;
begin
  if recflag=False then exit;

  maxlev:=0;

  for cnt:=0 to recsize-1 do begin
    data:=recbuf[cnt];
    if maxlev<abs(data) then maxlev:=abs(data);

    if (-recborder<data) and (data<recborder) then begin
//      inc(count);
      end else begin
      if lastdata<=0 then begin
        if data>=0 then begin
          lastdata:=data;
          data:=0;
          count:=(count+1) div 2;
          if ListBox1.Visible=True then ListBox1.Items.Add(inttostr(count));
          recvBitStream(count);
          count:=0;
          end else begin
          inc(count);
        end;
        end else begin
        if data<=0 then begin
          lastdata:=data;
          data:=0;
          count:=(count+1) div 2;
          if ListBox1.Visible=True then ListBox1.Items.Add(inttostr(count));
          recvBitStream(count);
          count:=0;
          end else begin
          inc(count);
        end;
      end;
    end;
  end;

  if datastr<>'' then begin
    memo1.Text:=memo1.Text+datastr;
    if Assigned(logwfs)=True then begin
      logwfs.WriteBuffer(datastr[1],length(datastr));
    end;

    datastr:='';
  end;

  maxlevy:=(maxlev*256) div $8000;
  with maxlevImg.Canvas do begin
    Brush.Style:=bsSolid;
    Brush.Color:=$000000;
    FillRect(rect(0,0,16,256));
    if maxlev<recborder then begin
      Brush.Color:=$0000ff;
      FillRect(rect(0,256-maxlevy,16,256));
      end else begin
      Brush.Color:=$ffff00;
      FillRect(rect(0,256-maxlevy,16,256-((recborder*256) div $8000)));
      Brush.Color:=$0000ff;
      FillRect(rect(0,256-((recborder*256) div $8000),16,256));
    end;
  end;

  recflag:=False;
end;

procedure TMain.StartRecord;
var
  freq:integer;
begin
  DDSDRecord.Free;

  freq:=44100;

  DDSDRecord:=TDDSDCapture.Create(DDSD);
  if DDSDRecord.IsSupportedFormat(freq,16,False) then begin
    DDSDRecord.SetupCaptureBuffer(freq,16,False,recsize*2);
    end else begin
    ShowMessage(inttostr(freq)+'Hz/16bit/Mono Ř^Jnł܂łB');
    Application.Terminate;
    exit;
  end;
  DDSDRecord.OnRecording:=DDSDRecordUpdate;
  DDSDRecord.StartLoop;
end;

procedure TMain.recborderBarChange(Sender: TObject);
begin
  recborder:=$7fff-recborderBar.Position;
  recborderLbl.Caption:=inttostr(recborder);
end;

end.
